---
title: Boolean
slug: Web/JavaScript/Reference/Global_Objects/Boolean
tags:
  - Boolean
  - Class
  - JavaScript
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>Boolean</code></strong> object is an object wrapper for a boolean value.</p>

<h2 id="Description">Description</h2>

<p>The value passed as the first parameter is converted to a boolean value, if necessary. If the value is omitted or is <code>0</code>, <code>-0</code>, {{jsxref("null")}}, <code>false</code>, {{jsxref("NaN")}}, {{jsxref("undefined")}}, or the empty string (<code>""</code>), the object has an initial value of <code>false</code>. All other values, including any object, an empty array (<code>[]</code>), or the string "<code>false</code>", create an object with an initial value of <code>true</code>.</p>

<p>Do not confuse the {{Glossary("Primitive", "primitive")}} <code>Boolean</code> values <code>true</code> and <code>false</code> with the <code>true</code> and <code>false</code> values of the <code>Boolean</code> object.</p>

<p><strong>Any</strong> object of which the value is not {{jsxref("undefined")}} or {{jsxref("null")}}, including a <code>Boolean</code> object whose value is <code>false</code>, evaluates to <code>true</code> when passed to a conditional statement. For example, the condition in the following {{jsxref("Statements/if...else", "if")}} statement evaluates to <code>true</code>:</p>

<pre class="brush: js notranslate">var x = new Boolean(false);
if (x) {
  // this code is executed
}
</pre>

<p>This behavior does not apply to <code>Boolean</code> primitives. For example, the condition in the following {{jsxref("Statements/if...else", "if")}} statement evaluates to <code>false</code>:</p>

<pre class="brush: js notranslate">var x = false;
if (x) {
  // this code is not executed
}
</pre>

<p>Do not use a <code>Boolean</code> object to convert a non-boolean value to a boolean value. To perform this task, instead, use <code>Boolean</code> as a function, or a <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_NOT">double NOT operator</a>:</p>

<pre class="brush: js notranslate">var x = Boolean(expression);     // use this...
var x = !!(expression);          // ...or this
var x = new Boolean(expression); // don't use this!
</pre>

<p>If you specify any object, including a <code>Boolean</code> object whose value is <code>false</code>, as the initial value of a <code>Boolean</code> object, the new <code>Boolean</code> object has a value of <code>true</code>.</p>

<pre class="brush: js notranslate">var myFalse = new Boolean(false);   // initial value of false
var g = Boolean(myFalse);       // initial value of true
var myString = new String('Hello'); // string object
var s = Boolean(myString);      // initial value of true
</pre>

<p>Do not use a <code>Boolean</code> object in place of a <code>Boolean</code> primitive.</p>

<div class="note">
<p><strong>Note:</strong> When the non-standard property <code><a href="/en-US/docs/Web/API/Document#Properties">document.all</a></code> is used as an argument for this constructor, the result is a <code>Boolean</code> object with the value <code>false</code>. This property is legacy and non-standard and should not be used.</p>
</div>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{jsxref("Global_Objects/Boolean/Boolean", "Boolean()")}}</dt>
 <dd>Creates a new <code>Boolean</code> object.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{jsxref("Boolean.prototype.toString()")}}</dt>
 <dd>Returns a string of either <code>true</code> or <code>false</code> depending upon the value of the object. Overrides the {{jsxref("Object.prototype.toString()")}} method.</dd>
 <dt>{{jsxref("Boolean.prototype.valueOf()")}}</dt>
 <dd>Returns the primitive value of the {{jsxref("Boolean")}} object. Overrides the {{jsxref("Object.prototype.valueOf()")}} method.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_Boolean_objects_with_an_initial_value_of_false">Creating Boolean objects with an initial value of false</h3>

<pre class="brush: js notranslate">var bNoParam = new Boolean();
var bZero = new Boolean(0);
var bNull = new Boolean(null);
var bEmptyString = new Boolean('');
var bfalse = new Boolean(false);
</pre>

<h3 id="Creating_Boolean_objects_with_an_initial_value_of_true">Creating <code>Boolean</code> objects with an initial value of <code>true</code></h3>

<pre class="brush: js notranslate">var btrue = new Boolean(true);
var btrueString = new Boolean('true');
var bfalseString = new Boolean('false');
var bSuLin = new Boolean('Su Lin');
var bArrayProto = new Boolean([]);
var bObjProto = new Boolean({});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-boolean-objects', 'Boolean')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Boolean")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Glossary/Boolean">Boolean</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Data_structures#Boolean_type">Boolean primitives</a></li>
 <li><a href="https://en.wikipedia.org/wiki/Boolean_data_type">Boolean data type (Wikipedia)</a></li>
</ul>
